/*
 * Copyright (C) 2020, KylinSoft Co., Ltd.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */
#ifndef CUSTOMMESSAGEBOX_H
#define CUSTOMMESSAGEBOX_H

#include <QDialog>
#include <QPushButton>
#include <QLabel>

class CustomMessageBox : public QDialog {
    Q_OBJECT

public:
    enum MessageBoxButton {
        OkButton = 1,
        CancelButton = 2,
        CloseButton =3
    };

    explicit CustomMessageBox(QWidget *parent = nullptr);

    void setMessage(const QString &message);
    void setButtons(int buttons);

    int clickedButton() const;

protected:
    void resizeEvent(QResizeEvent *event) override;

private:
    void initLayout();
    void initConnect();
    void checkTheme();

private slots:
    void onOkClicked();
    void onCancelClicked();
    void changeTheme();

private:
    QLabel *messageLabel;
    QLabel *iconLabel;
    QPushButton *okButton;
    QPushButton *cancelButton;
    QPushButton *closeButton;
    int m_clickedButton;

};

#endif // CUSTOMMESSAGEBOX_H
